/*
 * This file is generated by jOOQ.
 */
package jooq.model.tables.records;


import java.time.LocalDateTime;

import jooq.model.tables.Flight;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class FlightRecord extends UpdatableRecordImpl<FlightRecord> implements Record4<Long, LocalDateTime, LocalDateTime, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>public.flight.id</code>.
     */
    public void setId(Long value) {
        set(0, value);
    }

    /**
     * Getter for <code>public.flight.id</code>.
     */
    public Long getId() {
        return (Long) get(0);
    }

    /**
     * Setter for <code>public.flight.start_time</code>.
     */
    public void setStartTime(LocalDateTime value) {
        set(1, value);
    }

    /**
     * Getter for <code>public.flight.start_time</code>.
     */
    public LocalDateTime getStartTime() {
        return (LocalDateTime) get(1);
    }

    /**
     * Setter for <code>public.flight.end_time</code>.
     */
    public void setEndTime(LocalDateTime value) {
        set(2, value);
    }

    /**
     * Getter for <code>public.flight.end_time</code>.
     */
    public LocalDateTime getEndTime() {
        return (LocalDateTime) get(2);
    }

    /**
     * Setter for <code>public.flight.flight_status</code>.
     */
    public void setFlightStatus(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>public.flight.flight_status</code>.
     */
    public String getFlightStatus() {
        return (String) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Long> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row4<Long, LocalDateTime, LocalDateTime, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    @Override
    public Row4<Long, LocalDateTime, LocalDateTime, String> valuesRow() {
        return (Row4) super.valuesRow();
    }

    @Override
    public Field<Long> field1() {
        return Flight.FLIGHT.ID;
    }

    @Override
    public Field<LocalDateTime> field2() {
        return Flight.FLIGHT.START_TIME;
    }

    @Override
    public Field<LocalDateTime> field3() {
        return Flight.FLIGHT.END_TIME;
    }

    @Override
    public Field<String> field4() {
        return Flight.FLIGHT.FLIGHT_STATUS;
    }

    @Override
    public Long component1() {
        return getId();
    }

    @Override
    public LocalDateTime component2() {
        return getStartTime();
    }

    @Override
    public LocalDateTime component3() {
        return getEndTime();
    }

    @Override
    public String component4() {
        return getFlightStatus();
    }

    @Override
    public Long value1() {
        return getId();
    }

    @Override
    public LocalDateTime value2() {
        return getStartTime();
    }

    @Override
    public LocalDateTime value3() {
        return getEndTime();
    }

    @Override
    public String value4() {
        return getFlightStatus();
    }

    @Override
    public FlightRecord value1(Long value) {
        setId(value);
        return this;
    }

    @Override
    public FlightRecord value2(LocalDateTime value) {
        setStartTime(value);
        return this;
    }

    @Override
    public FlightRecord value3(LocalDateTime value) {
        setEndTime(value);
        return this;
    }

    @Override
    public FlightRecord value4(String value) {
        setFlightStatus(value);
        return this;
    }

    @Override
    public FlightRecord values(Long value1, LocalDateTime value2, LocalDateTime value3, String value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached FlightRecord
     */
    public FlightRecord() {
        super(Flight.FLIGHT);
    }

    /**
     * Create a detached, initialised FlightRecord
     */
    public FlightRecord(Long id, LocalDateTime startTime, LocalDateTime endTime, String flightStatus) {
        super(Flight.FLIGHT);

        setId(id);
        setStartTime(startTime);
        setEndTime(endTime);
        setFlightStatus(flightStatus);
        resetChangedOnNotNull();
    }
}
